<?php

namespace Drp\NativeEventApp\Test\Unit;

use Drp\NativeEventApp\Auth\ContactDetails;
use Drp\NativeEventApp\Enums\AuthMethod;
use Drp\NativeEventApp\Test\Support\Fakes\Delegate;
use Drp\NativeEventApp\Test\TestCase;

class HasAuthMethodsTest extends TestCase
{
    /**
     * @test
     */
    public function returns_available_auth_methods()
    {
        $delegate = new Delegate;
        tap($delegate->contactDetails(), function (ContactDetails $contactDetails) {
            $this->assertEquals(AuthMethod::SMS, $contactDetails->get(AuthMethod::SMS)->method);
            $this->assertEquals('777', $contactDetails->get(AuthMethod::SMS)->obfuscated());
            $this->assertEquals(AuthMethod::EMAIL, $contactDetails->get(AuthMethod::EMAIL)->method);
            $this->assertEquals('t**t@example.com', $contactDetails->get(AuthMethod::EMAIL)->obfuscated());
        });
    }

    /**
     * @test
     */
    public function can_route_to_mail()
    {
        $delegate = new Delegate;
        $this->assertEquals('test@example.com', $delegate->routeNotificationForMail());
    }

    /**
     * @test
     */
    public function can_route_to_sms()
    {
        $delegate = new Delegate;
        $this->assertEquals('447725854777', $delegate->routeNotificationForNexmo());
    }
}
